#include "stdafx.h"
#include "groupfile.h"
#include <string.h>
#include <memory.h>

#define NO_ERRORS 0

GroupFile::GroupFile(const char* filename):
//m_Files(NULL),
m_nNumFiles(0),
m_pFilePointer(NULL),
m_nStatus(0)
{
	//strncpy(m_sAuthorName, AuthorName, 12);

	memset(m_sFileName, 0, 255);
	strncpy(m_sFileName, filename, 255);

	Load();

}


GroupFile::GroupFile():
//m_Files(NULL),
m_nNumFiles(0),
m_pFilePointer(NULL),
m_nStatus(0)
{
}


//Clean up
GroupFile::~GroupFile()
{
	//if(m_Files)
	//{
		for(uint32 i = 0; i < m_nNumFiles; i++)
		{
			//TODO: Delete data for each file entry.
			if(m_Files[i].data != NULL)
			{
				delete[] m_Files[i].data;
				m_Files[i].data = NULL;
			}

		}

		//delete[] m_Files;
	//}
}

int GroupFile::Open(const char* sFlags)
{

	m_pFilePointer = fopen(m_sFileName, sFlags);
	if(m_pFilePointer == NULL)
	{
		return 1;
	}

	return 0;
}

int GroupFile::Load()
{
	if (Open("rb") == NO_ERRORS)
	{	
	
		//read name
		fread(&m_sAuthorName , sizeof(char), 12, m_pFilePointer);
		
		//read file num
		fread(&m_nNumFiles , sizeof(char), 4, m_pFilePointer);
	
		//m_Files = new FILESTRUCT[m_nNumFiles];
		m_Files.Grow(m_nNumFiles);
	
		//Read in file header info
		uint32 i = 0;
		for(i = 0; i < m_nNumFiles; i++)
		{
			fread(&m_Files[i].fileheader.name[0], sizeof(char), 12, m_pFilePointer);
			fread(&m_Files[i].fileheader.size, sizeof(char), 4, m_pFilePointer);	
		}
	
		//Read in file data
		for(i = 0; i < m_nNumFiles; i++)
		{
			uint32 nFileSize = m_Files[i].fileheader.size;
			m_Files[i].data = new unsigned char[nFileSize];
			if(m_Files[i].data != NULL)
			{
				fread(&m_Files[i].data[0], sizeof(char), nFileSize, m_pFilePointer);
			}
		}
		
		Close();
	}
	else
	{
		return 1;
	}

	return 0;
}

int GroupFile::Save()
{
	if (Open("wb") == NO_ERRORS)
	{	
	
		//Write author name name
		fwrite(&m_sAuthorName , sizeof(char), 12, m_pFilePointer);
		
		//Write file num
		fwrite(&m_nNumFiles , sizeof(char), 4, m_pFilePointer);
	
		//Write out file header info
		uint32 i = 0;
		for(i = 0; i < m_nNumFiles; i++)
		{
			fwrite(&m_Files[i].fileheader.name[0], sizeof(char), 12, m_pFilePointer);
			fwrite(&m_Files[i].fileheader.size, sizeof(char), 4, m_pFilePointer);
	
		}
	
		//Write out file data
		for(i = 0; i < m_nNumFiles; i++)
		{
			uint32 nFileSize = m_Files[i].fileheader.size;
			fwrite(&m_Files[i].data[0], sizeof(char), nFileSize, m_pFilePointer);
		}
		
		fflush(m_pFilePointer);
		
		Close();
	}
	else
	{
		return 1;
	}	
	
	return 0;
}

int GroupFile::Close()
{
	if(m_pFilePointer)
	{
		fclose(m_pFilePointer);
	}

	return 0;
}


void GroupFile::SetFilename(const char* sFilename)
{
	if(sFilename[0] != '\0')
	{
		memset(m_sFileName, 0, 255);
		sprintf(m_sFileName, "%s", sFilename);
	}
}

