#ifndef __LINKEDLIST_H_
#define __LINKEDLIST_H_

#include <malloc.h>
#include <stdlib.h>


template <class T> class LinkedMember
{
  public:
  LinkedMember()
  {
	  next = NULL; 
  }
  ~LinkedMember(){}
  
  T data;
  LinkedMember* next;
};

template <class T> class LinkedList
{
private:
	LinkedMember<T> *data;
	int m_nSize;
	
public:
	LinkedList()
	{  
		data = NULL;
		m_nSize = 0;
	}

	~LinkedList()
	{
		if(data != NULL)
		{
			FreeStack();
		} 
	}	
	
	int GetSize()
	{
		return m_nSize;
	}
	
	void FreeStack()
	{
		LinkedMember<T> *_data = data;
		
		for(;_data;)
		{
			LinkedMember<T> *pNext;
			pNext = _data->next;
			free(_data);
			_data = pNext;
		}
		data = NULL;
	}

	void Grow(unsigned int nAmount)
	{
		for(unsigned int i = 0; i < nAmount; i++)
		{
			LinkedMember<T> *stackmember;            
			stackmember = (LinkedMember<T>*)malloc( sizeof(LinkedMember<T>) );      
			if( stackmember != NULL )
			{
				stackmember->next = data;
				data = stackmember;
				m_nSize++;
			}
		}
	}

	T& operator [] (unsigned int i)
	{ 
		LinkedMember<T> *pNext;
		pNext = data;

		if(NULL != data)
		for(int j = 0; j < m_nSize; j++)
		{
			if(j == i)
			return pNext->data;

			pNext = pNext->next;
		}

		return data->data;//0x00;
	}
	
	void Append(T value)
	{
		LinkedMember<T> *stackmember;            
		stackmember = (LinkedMember<T>*)malloc( sizeof(LinkedMember<T>) );      
		if( stackmember != NULL )
		{
			stackmember->data = value;
			stackmember->next = data;
			data = stackmember;
			m_nSize++;
		}
	}

	void Remove(unsigned int i)
	{
		LinkedMember<T> *pPrev = NULL;
		LinkedMember<T> *pThis;
		pThis = data;

		if(NULL != data)
		for(unsigned int j = 0; j < m_nSize; j++)
		{
			if(j == i)
			{
				if(NULL == pPrev)
				{
					data = pThis->next;
				}
				else
				{
					pPrev->next = pThis->next;
				}

				if(pThis)
				{
					free(pThis);
					m_nSize--;
				}				

				return;
			}
			
			pPrev = pThis;
			pThis = pThis->next;
		}		
	}
	
};

#endif
