#include "stdafx.h"
#include "palettefile.h"
#include <string.h>

PaletteFile::PaletteFile(FILESTRUCT* data)
{
	if(data == NULL)
	{
		m_nStatus = BL_ERROR;
		return;
	}

	m_nStatus = BL_OK;

	//Get fileheader info
	strncpy(m_FileHeader.name, data->fileheader.name, 12);
	m_FileHeader.size = data->fileheader.size;	
	
	uint32 nMemOffset = 0; 
	memcpy(&m_Palette.palette, &data->data[nMemOffset], 768);
	nMemOffset += (sizeof(char) * 768);	
	
	memcpy(&m_Palette.numpalookups, &data->data[nMemOffset], 2);
	nMemOffset += (sizeof(char) * 2);	
	
	m_Palette.palookup = new uint8[m_Palette.numpalookups][256];
	memcpy(&m_Palette.palookup[0], &data->data[nMemOffset], (m_Palette.numpalookups * 256));
	nMemOffset += (sizeof(char) * (m_Palette.numpalookups * 256));
	
	memcpy(&m_Palette.transluc[0], &data->data[nMemOffset], 65536);
	nMemOffset += (sizeof(char) * 65536);			

}


PaletteFile::PaletteFile(const char* sFilename)
{
	m_nStatus = BL_OK;

	FILE *fp = fopen(sFilename, "rb");
	if(fp != NULL)
	{
		//memcpy(&m_Palette.palette, &data->data[nMemOffset], 768);
		//nMemOffset += (sizeof(char) * 768);
		fread(&m_Palette.palette, sizeof(char), 768, fp);

		//memcpy(&m_Palette.numpalookups, &data->data[nMemOffset], 2);
		//nMemOffset += (sizeof(char) * 2);	
		fread(&m_Palette.numpalookups, sizeof(char), 2, fp);

		m_Palette.palookup = new uint8[m_Palette.numpalookups][256];
		//memcpy(&m_Palette.palookup[0], &data->data[nMemOffset], (m_Palette.numpalookups * 256));
		//nMemOffset += (sizeof(char) * (m_Palette.numpalookups * 256));
		fread(&m_Palette.palookup[0], sizeof(char), (m_Palette.numpalookups*256), fp);


		//memcpy(&m_Palette.transluc[0], &data->data[nMemOffset], 65536);
		//nMemOffset += (sizeof(char) * 65536);
		fread(&m_Palette.transluc[0], sizeof(char), 65536, fp);

		fclose(fp);
	}
	else
	{
		m_nStatus = BL_ERROR;
	}
}

PaletteFile::PaletteFile()
{
	m_nStatus = BL_OK;
}

PaletteFile::~PaletteFile()
{

	if(m_Palette.palookup)
	{
		delete[] m_Palette.palookup;
	}
	/*
	if(m_Art.tiles)
	{
		for(uint32 i = 0; i <m_Art.nNumTiles; i++)
		{
			//delete each tile's data
			if( m_Art.tiles[i].data )
			{
				delete[] m_Art.tiles[i].data;
			}
		}
		delete[] m_Art.tiles;
	}
	*/

}

